// Squawk messenger. 
// Copyright (C) 2019  Yury Gubich <blue@macaw.me>
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

#ifndef SHARED_FIELD_H
#define SHARED_FIELD_H

#include <list>

#include <QString>
#include <QVariant>

namespace Shared {

/**
 * @todo write docs
 */
class Field
{
public:
    enum class Type {
        boolean,
        fixed,
        hidden,
        jidMultiple,
        jidSingle,
        listMultiple,
        listSingle,
        textMultiple,
        textPrivate,
        textSingle
    };

    Field(Type fieldType);

public:
    const Type type;
    QString key;
    QString label;
    QString description;
    bool required;
    std::list<std::pair<QString, QString>> options;
    QVariant value;

};

}

#endif // SHARED_FIELD_H
