/*
 * Squawk messenger.
 * Copyright (C) 2019  Yury Gubich <blue@macaw.me>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef SHARED_IDENTITY_H
#define SHARED_IDENTITY_H

#include <QDataStream>
#include <QString>

namespace Shared {

class Identity {
public:
    Identity();

    QDataStream& operator << (QDataStream& stream);
    QDataStream& operator >> (QDataStream& stream) const;

    bool operator < (const Identity& other) const;
    bool operator > (const Identity& other) const;
    bool operator >= (const Identity& other) const;
    bool operator <= (const Identity& other) const;
    bool operator == (const Identity& other) const;
    bool operator != (const Identity& other) const;
public:
    QString category;
    QString type;
    QString language;
    QString name;
};

}

QDataStream& operator << (QDataStream& stream, const Shared::Identity& identity);
QDataStream& operator >> (QDataStream& stream, Shared::Identity& identity);

#endif //SHARED_IDENTITY_H
