// Squawk messenger. 
// Copyright (C) 2019  Yury Gubich <blue@macaw.me>
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

#ifndef SHARED_INFO_H
#define SHARED_INFO_H

#include "vcard.h"
#include "keyinfo.h"
#include "enums.h"

#include <list>

namespace Shared {

/**
 * This class should contain all nessesary data to display
 * roster element info (contact, or out of roster contact, or MUC, or MIX in the future)
 *
 * under development yet
 */
class Info {
public:
    Info();
    Info(const QString& jid, EntryType = EntryType::contact, bool editable = false);
    Info(const Info& other);
    ~Info();

    EntryType type;
    QString jid;
    bool editable;
    VCard vcard;
    std::list<KeyInfo> activeKeys;
    std::list<KeyInfo> inactiveKeys;
};

}

#endif // SHARED_INFO_H
